/*global jQuery:false */

// Dependencies: easy-pie-chart.js

(function ($) {
    "use strict";
    
    var $window = $(window);
    
    function isElementInViewport (el) {
        if (el.length === 0) {
            return false;
        } else {
            el = el[0];
        }
        
        var rect = el.getBoundingClientRect();
        return (
            rect.top >= 0 &&
            rect.left >= 0 &&
            rect.bottom <= $window.height() &&
            rect.right <= $window.width()
        );
    }
	
	function startProgresschartAnimation () {
		var $progresschart = $('.pie .chart');
	
		$progresschart.easyPieChart({
			scaleColor: false,
			size: 220,
			lineWidth: 14,
			animate: $(this).data('duration'),
			onStep: function (from, to, percent) {
				$(this.el).find('.percent').text(Math.round(percent));
			}
		});
		
        $progresschart.each(function () {
			
			var $this = $(this),
				$value = $this.data('value');
			
			if (isElementInViewport($this) && $this.data('animate') != 'off') {
				$this.data('animate', 'off');
				$this.data('easyPieChart').enableAnimation().update($value); // Initial value: data-percent="0" -> Get value via new attribute data-value="$(this).data('value')"
			}
			
            if (!isElementInViewport($this)) {
				$this.data('animate', 'on');
                $this.data('easyPieChart').enableAnimation().update(0);
            }
        });
    }
    
    $window.on('load scroll touchmove', function () {
        startProgresschartAnimation();
    });
    
}(jQuery));