/*global jQuery:false */

// Dependencies: boostrap.js

(function ($) {
    "use strict";
    
    var $window = $(window);
    
    function isElementInViewport (el) {
        if (el.length === 0) {
            return false;
        } else {
            el = el[0];
        }
        
        var rect = el.getBoundingClientRect();
        return (
            rect.top >= 0 &&
            rect.left >= 0 &&
            rect.bottom <= $window.height() &&
            rect.right <= $window.width()
        );
    }
    
    function startProgressbarAnimation () {
        var $progressbar = $('.progress-bar');
        
        $progressbar.each(function (i, el) {
            if (isElementInViewport($(this))) {
                $(this).css("width",
                    function () {
                        return $(this).attr("aria-valuenow") + "%";
                    }
                );
            }
            
            if (!isElementInViewport($(this))) {
                $(this).css("width", "");
            }
        });
    }
    
	// Initialize countTo on scroll/touchmove, if in viewport
    $window.on('load scroll touchmove', function () {
        startProgressbarAnimation();
    });
    
}(jQuery));